# keystoneauth1.identity.v3.password module

class keystoneauth1.identity.v3.password.Password(auth_url: str, password: str, user_id: str | None = None, username: str | None = None, user_domain_id: str | None = None, user_domain_name: str | None = None, *, unscoped: bool = False, trust_id: str | None = None, system_scope: str | None = None, domain_id: str | None = None, domain_name: str | None = None, project_id: str | None = None, project_name: str | None = None, project_domain_id: str | None = None, project_domain_name: str | None = None, reauthenticate: bool = True, include_catalog: bool = True)

  Bases: `Auth`

  A plugin for authenticating with a username and password.

  Parameters:

    - auth_url (string) – Identity service endpoint for authentication.

    - password (string) – Password for authentication.

    - user_id (string) – User ID for authentication.

    - username (string) – Username for authentication.

    - user_domain_id (string) – User’s domain ID for authentication.

    - user_domain_name (string) – User’s domain name for authentication.

    - trust_id (string) – Trust ID for trust scoping.

    - system_scope (string) – System information to scope to.

    - domain_id (string) – Domain ID for domain scoping.

    - domain_name (string) – Domain name for domain scoping.

    - project_id (string) – Project ID for project scoping.

    - project_name (string) – Project name for project scoping.

    - project_domain_id (string) – Project’s domain ID for project.

    - project_domain_name (string) – Project’s domain name for project.

    - reauthenticate (bool) – Allow fetching a new token if the current one is going to expire. (optional) default True

  __abstractmethods__ = frozenset({})
  __annotations_cache__ = {'MIN_TOKEN_LIFE_SECONDS': 'int', '_discovery_cache': 'dict[str, discover.Discover]', 'auth_ref': 'access.AccessInfo | None', 'auth_url': 'str', 'reauthenticate': 'bool'}
  __doc__ = "A plugin for authenticating with a username and password.\n\n:param string auth_url: Identity service endpoint for authentication.\n:param string password: Password for authentication.\n:param string user_id: User ID for authentication.\n:param string username: Username for authentication.\n:param string user_domain_id: User's domain ID for authentication.\n:param string user_domain_name: User's domain name for authentication.\n:param string trust_id: Trust ID for trust scoping.\n:param string system_scope: System information to scope to.\n:param string domain_id: Domain ID for domain scoping.\n:param string domain_name: Domain name for domain scoping.\n:param string project_id: Project ID for project scoping.\n:param string project_name: Project name for project scoping.\n:param string project_domain_id: Project's domain ID for project.\n:param string project_domain_name: Project's domain name for project.\n:param bool reauthenticate: Allow fetching a new token if the current one\n is going to expire. (optional) default True\n"
  __firstlineno__ = 83
  __init__(auth_url: str, password: str, user_id: str | None = None, username: str | None = None, user_domain_id: str | None = None, user_domain_name: str | None = None, *, unscoped: bool = False, trust_id: str | None = None, system_scope: str | None = None, domain_id: str | None = None, domain_name: str | None = None, project_id: str | None = None, project_name: str | None = None, project_domain_id: str | None = None, project_domain_name: str | None = None, reauthenticate: bool = True, include_catalog: bool = True) → None
  __module__ = 'keystoneauth1.identity.v3.password'
  __static_attributes__ = ()
  _abc_impl = <_abc._abc_data object>
  _auth_method_class

    alias of `PasswordMethod`

  _discovery_cache: dict[str, discover.Discover]
  auth_ref: access.AccessInfo | None
  auth_url: str
  reauthenticate: bool

class keystoneauth1.identity.v3.password.PasswordMethod(*, password: str, user_id: str | None = None, username: str | None = None, user_domain_id: str | None = None, user_domain_name: str | None = None)

  Bases: `AuthMethod`

  Construct a User/Password based authentication method.

  Parameters:

    - password (string) – Password for authentication.

    - username (string) – Username for authentication.

    - user_id (string) – User ID for authentication.

    - user_domain_id (string) – User’s domain ID for authentication.

    - user_domain_name (string) – User’s domain name for authentication.

  __abstractmethods__ = frozenset({})
  __annotations_cache__ = {'_method_parameters': 'list[str] | None', 'password': <class 'str'>, 'user_domain_id': str | None, 'user_domain_name': str | None, 'user_id': str | None, 'username': str | None}
  __doc__ = "Construct a User/Password based authentication method.\n\n:param string password: Password for authentication.\n:param string username: Username for authentication.\n:param string user_id: User ID for authentication.\n:param string user_domain_id: User's domain ID for authentication.\n:param string user_domain_name: User's domain name for authentication.\n"
  __firstlineno__ = 21
  __init__(*, password: str, user_id: str | None = None, username: str | None = None, user_domain_id: str | None = None, user_domain_name: str | None = None) → None
  __module__ = 'keystoneauth1.identity.v3.password'
  __static_attributes__ = ('password', 'user_domain_id', 'user_domain_name', 'user_id', 'username')
  _abc_impl = <_abc._abc_data object>
  get_auth_data(session: Session, auth: Auth, headers: dict[str, str], request_kwargs: dict[str, object]) → tuple[None, None] | tuple[str, Mapping[str, object]]

    Return the authentication section of an auth plugin.

    Parameters:

      - session (keystoneauth1.session.Session) – The communication session.

      - auth (base.Auth) – The auth plugin calling the method.

      - headers (dict) – The headers that will be sent with the auth request if a plugin needs to add to them.

    Returns:

      The identifier of this plugin and a dict of authentication data for the auth type.

    Return type:

      tuple(string, dict)

  get_cache_id_elements() → dict[str, str | None]

    Get the elements for this auth method that make it unique.

    These elements will be used as part of the `keystoneauth1.plugin.BaseIdentityPlugin.get_cache_id()` to allow caching of the auth plugin.

    Plugins should override this if they want to allow caching of their state.

    To avoid collision or overrides the keys of the returned dictionary should be prefixed with the plugin identifier. For example the password plugin returns its username value as ‘password_username’.

  password: str
  user_domain_id: str | None = None
  user_domain_name: str | None = None
  user_id: str | None = None
  username: str | None = None

this page last updated: 2026-03-25 21:01:07

Except where otherwise noted, this document is licensed under Creative Commons Attribution 3.0 License. See all OpenStack Legal Documents.

found an error? report a bug